#!/usr/bin/perl
# ġ   .

#-DON'T REMOVE>>-----------------------------------------------------
# Picuture BBS - Read PNG File Program ($Revision: 1.1 $)
#                       Copyright (C) Yasuo OHNO <ohno@cds.ne.jp>, 2000
#                                                  All rights reserved.
#   ǡ  Ʒ Ʈ Ͻʽÿ
#   - SCENERY AND FISH - http://www16.cds.ne.jp/~ohno/
#   - Ȼߺ񿡾 - http://picbbs.com (ѱ Ʈ)
#-----------------------------------------------------<< DON'T REMOVE -

#----------------------------------------------------------------------
# 
#----------------------------------------------------------------------

#  ڵ
$ERR_FATAL    = '000';
$ERR_LOCK     = '001';
$ERR_BUSY     = '002';
$ERR_PNGSIZE  = '003';
$ERR_MSGSIZE  = '004';
$ERR_PASSWORD = '005';
$ERR_PERM     = '006';


#----------------------------------------------------------------------
# ʱȭ
#----------------------------------------------------------------------

$maketemp     = 0;


#----------------------------------------------------------------------
# main
#----------------------------------------------------------------------

#   б
require 'config.cgi';

binmode(STDIN);
_putappheader();

# POST  Ͽ  ȣƮ Ȯ
if (! _checkhost()) {
    nack($ERR_PERM);
}

$content_length = $ENV{'CONTENT_LENGTH'};
if ($content_length < 8) {
    nack($ERR_FATAL);
}

if (read(STDIN, $ext, 3) != 3) {
    nack($ERR_FATAL);
}
$content_length -= 3;

if (read(STDIN, $pngsize, 8) != 8) {
    nack($ERR_FATAL);
}
$content_length -= 8;

$pngsize = int($pngsize);

if ($pngsize > $g_pngmax) {
    nack($ERR_PNGSIZE);
}

if (($content_length - $pngsize) > $g_msgmax) {
    nack($ERR_MSGSIZE);
}

if ($pngsize > $content_length) {
    nack($ERR_FATAL);
}

if (! _lock()) {
    nack($ERR_LOCK);
}

$pngtemp = _gettemporarily();
_unlock();

if (! receive_png_file($pngtemp, $pngsize)) {
    nack($ERR_FATAL);
}
$content_length -= $pngsize;

binmode(STDIN);
if (! _parseform($content_length)) {
    nack($ERR_FATAL);
}

# Էġ Ȯ
if ($FORM{'PASSWORD'} eq '') {
    nack($ERR_PASSWORD);
}

if (! _lock()) {
    nack($ERR_LOCK);
}

# б  
if (! open(LOGIN, $g_logfile)) {
    nack($ERR_FATAL);
}

#   
if (! open(LOGOUT, '>' . $g_logtemp)) {
    nack($ERR_FATAL);
}

#  б
$in = <LOGIN>;
chomp($in);
($nextbase, $nextpng) = split(/\t/, $in);
if ($nextbase == 0 || $nextpng == 0) {
    nack($ERR_FATAL);
}

#  
$basenum = $nextbase++;
$pngfile = sprintf("%d." . $ext, $nextpng++);
$password= _crypt($FORM{'PASSWORD'});
$timestr = _gettimestr(_time());
$remote  = _getremoteaddress();

print LOGOUT $nextbase . "\t" . $nextpng . "\n";

# picture  
print LOGOUT "${basenum}\t0\t${pngfile}\t0\t${password}\t\t\t\t${remote}\t${timestr}\t\t\n";

# б  
$count = 1;
READWRITE_LOOP: while (<LOGIN>) {
    ($current) = split(/\t/, $_);
    if ($basenum != $current) {
        $basenum = $current;
        $count++;
        if ($count > $g_logmax) {
            last READWRITE_LOOP;
        }
    }
    print LOGOUT $_;
}
close(LOGOUT);

# PNG  Ұ 
if ($count > $g_logmax) {
    do {
        ($basenum, $mode, $removefile) = split(/\t/, $_);
        if ($basenum != 0 && $mode == 0) {
            unlink "$g_pngwdir/$removefile";
        }
    } while (<LOGIN>);
}

close(LOGIN);

if (! rename($g_logtemp, $g_logfile)) {
    sleep(1);
    if (! rename($g_logtemp, $g_logfile)) {
    # ⿡ ϸ  ׸ . α״ .
        nack($ERR_FATAL);
    }
}

if (! rename($pngtemp, $g_pngwdir . '/' . $pngfile)) {
    sleep(1);
    if (! rename($pngtemp, $g_pngwdir . '/' . $pngfile)) {
   # ⿡ Ѵٸ ׸ Ҽ  ׸ 縸 Ҽ .
        nack($ERR_FATAL);
    }
}

_unlock();

print "ACK\n";
exit 0;


#----------------------------------------------------------------------
#  
#----------------------------------------------------------------------
# argument:
#   0 -  ڵ

sub nack {
    remove_tempfile();
    _unlock();
    print "NACK $_[0]\n";
    exit 0;
}


#----------------------------------------------------------------------
# PNG  
#----------------------------------------------------------------------
# argument:
#   0:$filename -  ̸
#   1:$size     -  

sub receive_png_file {
    my $filename = $_[0];
    my $size = $_[1];
    my $buffer;

    if (! open(TEMPOUT, ">$filename")) {
        return 0;
    }
    binmode(TEMPOUT);
    $maketemp = 1;
    $tempfile = $filename;

    while ($size > 0) {
        # б  
        if ($size > 4096) {
            $readsize = 4096;
        }
        else {
            $readsize = $size;
        }

        # б
        if (read(STDIN, $buffer, $readsize) != $readsize) {
            close(TEMPOUT);
            return 0;
        }
        $size -= $readsize;

        # 
        if (! print TEMPOUT $buffer) {
            close(TEMPOUT);
            return 0;
        }
    }

    close(TEMPOUT);
    return 1;
}


#----------------------------------------------------------------------
# ӽ   ó
#----------------------------------------------------------------------
# memo:
#   ӽ  ۼǰ ִٸ մϴ٣

sub remove_tempfile {
    if ($maketemp) {
        unlink $tempfile;
        $maketemp = 0;
    }
}


#----------------------------------------------------------------------
#  ƾ
#----------------------------------------------------------------------

END {
    remove_tempfile();
}
   